select.arch              package:unknown                R Documentation

SELEÇÃO E LEITURA DE ARQUIVOS DE ÁUDIO 

Description:

Função para auxiliar na separação de arquivos de interesse quando há muitos arquivos dentro do mesmo diretório. 
Planejada pensando em arquivos de áudio para quem trabalha com bioacústica e tem uma tabela com as informação de cada arquivo, contendo a data de gravação.
A função retorna os arquivos de áudio selecionados em uma pasta a parte, assim como os respectivos espectogramas caso seja solicitado.

Usage:
  
select.arch<-function(diretorio, diretorio2, data.i=NULL, data.f=NULL, aleat=0, read.sound=F)
    
Arguments:
  
diretorio: argumento que indica o diretório de trabalho onde estão os arquivos a serem selecionados. 

diretorio2: argumento que indica o diretório onde os arquivos selecionados serão copiados. A pasta final DEVE se chamar "arquivos_selecionados". 

data.i: argumento que indica a data inicial de interesse para seleção do arquivo (formato "AAAA-MM-DD").

data.f: argumento que indica a data final de interesse para seleção do arquivo (formato "AAAA-MM-DD").

aleat: argumento que indica a quantidade de arquivos para retornar. Esses arquivos são escolhidos aleatoriamente dentro do período de interesse indicado pelo usuário através da função "sample".
Se o usuário quiser todos os arquivos do intervalo, basta determinar "aleat=0".

read.sound: argumento que indica se os espectogramas dos arquivos selecionados serão gerados.

Details:

Se atente a presença do caracter "#" na tabela com as informações de data. Alguns gravadores usam esse caracter e atrapalham a leitura de dados no R. Se a sua tabela tiver "#", você deverá tirar antes de iniciar o uso da função.
Para criar o espectograma, usamos f=22050Hz.

#Value:
  
comp1: Os arquivos selecionados estão salvos no diretorio2.
comp2: Os arquivos selecionados estão salvos no diretorio2 e os espectogramas no diretorio(eles podem demorar serem criados na pasta
Pasta chamada arquivos_selecionados com a seleção feita pela função.

#Warning:
  
É necessário que exista uma tabela com as datas que os arquivos foram gravados, além de carregá-la em um objeto chamado "tabela".
O gravador SM4 da WildLife Acoustic, por exemplo, grava em um formato de data que não é lido pelo R (2019-May-25), por isso é preciso substituir o mês pelo número correspondente (use a função "gsub"). Por exemplo: tabela.data.a<-gsub("Jan",01,tabela.data) ###substitui Jan por mês=1
O modelo desse arquivo pode ser encontrado nesse #link.
O ideal é manter a pasta de destino dos arquivos e espectogramas vazia, assim você terá mais controle do que foi copiado pela função. Além disso, a função não irá copiar arquivos de mesmo nome. 
O argumento diretorio2 deve ter como pasta final "arquivos_selecionados". Essa pasta será criada na função, mas para que ela funcione, você deve escrever esse nome no argumento diretorio2.

Author(s):
  
Juliana Fernandes Primon
jufprimon@gmail.com

References:

Pacote "seewave": https://cran.r-project.org/web/packages/seewave/index.html
Pacote "sound": https://cran.r-project.org/web/packages/sound/index.html
Pacote "audio": https://cran.r-project.org/web/packages/sound/index.html
Pacote "tuneR": https://cran.r-project.org/web/packages/tuneR/index.html

See Also:
  
Para saber mais sobre gravadores:https://www.wildlifeacoustics.com/products/song-meter-sm4

Example:

select.arch(diretorio, diretorio2, data.i="2019-05-30", data.f="2019-06-01", aleat=10, read.sound=T)
diretorio="/Users/juprimon/arquivos_r"
diretorio2="/Users/juprimon/arquivos_r/arquivos_selecionados"

